/* message.h    Header file for Dopewars message-handling routines */

#ifndef __MESSAGE_H__
#define __MESSAGE_H__

#include "dopewars.h"

#define C_PRINTMESSAGE 'A'
#define C_LIST         'B'
#define C_ENDLIST      'C'
#define C_NEWNAME      'D' 
#define C_MSG          'E'
#define C_MSGTO        'F'
#define C_JOIN         'G'
#define C_LEAVE        'H'
#define C_SUBWAYFLASH  'I'
#define C_UPDATE       'J'
#define C_DRUGHERE     'K'
#define C_GUNSHOP      'L'
#define C_LOANSHARK    'M'
#define C_BANK         'N'
#define C_QUESTION     'O'
#define C_SAYING       'P'
#define C_HISCORE      'Q'
#define C_STARTHISCORE 'R' 
#define C_ENDHISCORE   'S'
#define C_BUYOBJECT    'T'
#define C_DONE         'U'
#define C_REQUESTJET   'V'
#define C_PAYLOAN      'W'
#define C_ANSWER       'X'
#define C_DEPOSIT      'Y'
#define C_PUSH         'Z'
#define C_QUIT         'a'
#define C_RENAME       'b'
#define C_NAME         'c'
#define C_SACKBITCH    'd'
#define C_TIPOFF       'e'
#define C_SPYON        'f'
#define C_WANTQUIT     'g'
#define C_CONTACTSPY   'h'
#define C_KILL         'i'

struct TMessageList {
   char Message[BUFLEN];
   struct TMessageList *Next;
};
typedef struct TMessageList MessageList;

void SendClientMessage(struct PLAYER *From,char AICode,char Code,
                       struct PLAYER *To,char *Data);
void SendServerMessage(struct PLAYER *From,char AICode,char Code,
                       struct PLAYER *To,char *Data);
void SendPrintMessage(struct PLAYER *From,char AICode,
                      struct PLAYER *To,char *Data);
void SendQuestion(struct PLAYER *From,char AICode,
                  struct PLAYER *To,char *Data);
void AddWaitingClientMessage(struct PLAYER *To,char *Text);
char CheckWaitingClientMessage(struct PLAYER *To,char *Text);
void ClearWaitingClientMessages();
char *bgets(char *buf,int maxlen,int fd);
void chomp(char *str);
void BroadcastToClients(char AICode,char Code,char *Data,struct PLAYER *From,
                        struct PLAYER *Except);
void SendInventory(struct PLAYER *From,char AICode,char Code,struct PLAYER *To,
                   Inventory *Inven);
void ReceiveInventory(char *Data,Inventory *Inven);
void SendPlayerData(struct PLAYER *To);
void SendSpyReport(struct PLAYER *To,struct PLAYER *SpiedOn);
void ReceivePlayerData(char *text,struct PLAYER *From);
char *ExtractWord(char *NewWord,char *text);
char *SetupNetwork();
void ShutdownNetwork();
int ProcessMessage(char *Msg,struct PLAYER **From,char *AICode,char *Code,
                   struct PLAYER **To,char *Data,struct PLAYER *First);
void ReceiveDrugsHere(char *text,struct PLAYER *To);

#endif
